
/*  A Bison parser, made from parse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	CLASS	257
#define	FROM	258
#define	CONST	259
#define	VOID	260
#define	STRUCT	261
#define	UNION	262
#define	ENUM	263
#define	THREEDOTS	264
#define	SIGNED	265
#define	UNSIGNED	266
#define	LONG	267
#define	SHORT	268
#define	INT	269
#define	FLOAT	270
#define	DOUBLE	271
#define	CHAR	272
#define	ONERROR	273
#define	TOKEN	274
#define	NUMBER	275
#define	TYPETOKEN	276
#define	ARRAY_DIM	277
#define	CCODE	278
#define	HCODE	279
#define	PUBLIC	280
#define	PRIVATE	281
#define	PROTECTED	282
#define	ARGUMENT	283
#define	VIRTUAL	284
#define	SIGNAL	285
#define	OVERRIDE	286

#line 21 "parse.y"


#include "config.h"
#include <glib.h>
#include <stdio.h>
#include <string.h>

#include "tree.h"
#include "main.h"

#define _(x) (x)
	
extern char *filename;
	
GList *nodes = NULL;

static GList *class_nodes = NULL;
Node *class = NULL;

static GList *typestack = NULL;
static int stars = 0;
static GList *funcargs = NULL;
static GList *checks = NULL;
static int has_self = FALSE;
static int vararg = FALSE;

static GList *gtktypes = NULL;

/* this can be a global as we will only do one function at a time
   anyway */
static int the_scope = NO_SCOPE;

void free(void *ptr);
int yylex(void);

extern int ccode_line;
extern int line_no;

extern char *yytext;

static void
yyerror(char *str)
{
	char *out=NULL;
	char *p;
	
	if(strcmp(yytext,"\n")==0) {
		out=g_strconcat("Error: ",str," before newline",NULL);
	} else if(yytext[0]=='\0') {
		out=g_strconcat("Error: ",str," at end of input",NULL);
	} else {
		char *tmp = g_strdup(yytext);
		while((p=strchr(tmp,'\n')))
			*p='.';

		out=g_strconcat("Error: ",str," before '",tmp,"'",NULL);
		g_free(tmp);
	}

	fprintf(stderr,"%s:%d: %s\n",filename,line_no,out);
	g_free(out);
	
	exit(1);
}

static Type *
pop_type(void)
{
	Type *type = typestack->data;
	typestack = g_list_remove(typestack,typestack->data);
	return type;
}

static void
push_variable(char *name, int scope, int line_no, char *postfix)
{
	Node *var;
	Type *type = pop_type();

	type->postfix = postfix;
	
	var = new_variable(scope,type,name,line_no);
	class_nodes = g_list_append(class_nodes, var);
}

static void
push_function(int scope, int method, char *oid, char *id, char *onerror,
	      GString *cbuf,int line_no, int ccode_line, int vararg)
{
	Node *node;
	Type *type;
	char *c_cbuf;
       
	if(method!=INIT_METHOD && method!=CLASS_INIT_METHOD) {
		type = pop_type();
	} else {
		type = (Type *)new_type(0,g_strdup("void"),NULL);
	}
	
	/* a complicated and ugly test to figure out if we have
	   the wrong number of types for a signal */
	if((method == SIGNAL_FIRST_METHOD ||
	    method == SIGNAL_LAST_METHOD) &&
	   g_list_length(gtktypes) != g_list_length(funcargs) &&
	   !(g_list_length(funcargs) == 1 &&
	     g_list_length(gtktypes) == 2 &&
	     strcmp(gtktypes->next->data,"NONE")==0)) {
		print_error(TRUE, _("The number of GTK arguments and "
				    "function arguments for a signal "
				    "don't seem to match"),line_no);
	}
	if(cbuf) {
		char *p;
		c_cbuf = p = cbuf->str;
		while(p && *p && (*p==' ' || *p=='\t' || *p=='\n' || *p=='\r'))
			p++;
		if(!p || !*p)
			c_cbuf = NULL;
	} else
		c_cbuf = NULL;

	node = new_method(scope,method,type,oid,gtktypes,id,funcargs,
			  onerror,c_cbuf,line_no,ccode_line,vararg);

	if(cbuf)
		g_string_free(cbuf,
			      /*only free segment if we haven't passed it
				above */
			      c_cbuf?FALSE:TRUE);
	gtktypes = NULL;
	funcargs = NULL;

	class_nodes = g_list_append(class_nodes, node);
}

static void
push_funcarg(char *name, char *postfix)
{
	Node *node;
	Type *type = pop_type();

	type->postfix = postfix;
	
	node = new_funcarg(type,name,checks);
	checks = NULL;
	
	funcargs = g_list_append(funcargs, node);
}

static void
push_init_arg(char *name, int is_class)
{
	Node *node;
	Node *type;
	char *tn;
	
	if(is_class)
		tn = g_strconcat(((Class *)class)->otype,":Class",NULL);
	else
		tn = g_strdup(((Class *)class)->otype);

	type = new_type(1,tn,NULL);
	node = new_funcarg((Type *)type,name,NULL);
	funcargs = g_list_prepend(funcargs, node);
}

static void
push_self(char *id)
{
	Node *node;
	Node *type;
	GList *ch = NULL;
	type = new_type(1,g_strdup(((Class *)class)->otype),NULL);
	ch = g_list_append(ch,new_check(NULL_CHECK,NULL));
	ch = g_list_append(ch,new_check(TYPE_CHECK,NULL));
	node = new_funcarg((Type *)type,id,ch);
	funcargs = g_list_prepend(funcargs, node);
}


#line 202 "parse.y"
typedef union {
	char *id;
	GString *cbuf;
	GList *list;
	int line;
	int sigtype;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		219
#define	YYFLAG		-32768
#define	YYNTBASE	46

#define YYTRANSLATE(x) ((unsigned)(x) <= 286 ? yytranslate[x] : 77)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    44,     2,     2,     2,     2,     2,     2,    36,
    37,    39,     2,    40,    45,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    35,    42,
    43,    41,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    33,    38,    34,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     4,     7,    10,    12,    15,    18,    20,    22,    27,
    31,    36,    39,    42,    45,    47,    49,    51,    53,    55,
    57,    62,    68,    80,    89,    95,    97,   101,   102,   106,
   108,   110,   113,   115,   118,   121,   124,   126,   129,   132,
   134,   136,   138,   140,   143,   145,   147,   150,   152,   155,
   157,   159,   161,   163,   165,   168,   170,   173,   175,   179,
   183,   186,   188,   193,   197,   199,   202,   204,   214,   225,
   235,   245,   254,   266,   275,   281,   284,   288,   289,   291,
   293,   297,   299,   303,   305,   309,   311,   314,   318,   325,
   333,   336,   338,   340,   343,   346,   350,   354,   358,   362,
   364,   367
};

static const short yyrhs[] = {    47,
    48,    47,     0,    48,    47,     0,    47,    48,     0,    48,
     0,    47,    24,     0,    47,    25,     0,    24,     0,    25,
     0,    49,    33,    50,    34,     0,    49,    33,    34,     0,
     3,    22,     4,    22,     0,    50,    68,     0,    50,    52,
     0,    50,    53,     0,    68,     0,    52,     0,    53,     0,
    26,     0,    27,     0,    28,     0,    51,    57,    20,    35,
     0,    51,    57,    20,    23,    35,     0,    29,    55,    54,
    20,    20,    33,    24,    20,    33,    24,    35,     0,    29,
    55,    54,    20,    20,    33,    24,    35,     0,    20,    36,
    20,    57,    37,     0,    20,     0,    36,    56,    37,     0,
     0,    20,    38,    56,     0,    20,     0,    58,     0,     5,
    58,     0,    59,     0,    59,    62,     0,    12,    60,     0,
    11,    60,     0,    60,     0,    12,    18,     0,    11,    18,
     0,    18,     0,    17,     0,    16,     0,    20,     0,    61,
    20,     0,    22,     0,     6,     0,    13,    15,     0,    13,
     0,    14,    15,     0,    14,     0,    15,     0,     9,     0,
     8,     0,     7,     0,    39,    62,     0,    39,     0,    20,
    65,     0,    65,     0,    51,    20,    65,     0,    20,    51,
    65,     0,    51,    65,     0,    63,     0,    20,    36,    66,
    37,     0,    66,    40,    20,     0,    20,     0,    33,    24,
     0,    35,     0,    31,    64,    57,    20,    36,    70,    37,
    69,    67,     0,    51,    31,    63,    57,    20,    36,    70,
    37,    69,    67,     0,    30,    51,    57,    20,    36,    70,
    37,    69,    67,     0,    51,    30,    57,    20,    36,    70,
    37,    69,    67,     0,    30,    57,    20,    36,    70,    37,
    69,    67,     0,    32,    36,    22,    37,    57,    20,    36,
    70,    37,    69,    67,     0,    51,    57,    20,    36,    70,
    37,    69,    67,     0,    20,    36,    20,    37,    67,     0,
    19,    76,     0,    19,    33,    24,     0,     0,     6,     0,
    20,     0,    20,    40,    71,     0,    71,     0,    72,    40,
    10,     0,    72,     0,    72,    40,    73,     0,    73,     0,
    57,    20,     0,    57,    20,    23,     0,    57,    20,    36,
    20,    74,    37,     0,    57,    20,    23,    36,    20,    74,
    37,     0,    74,    75,     0,    75,     0,    20,     0,    41,
    76,     0,    42,    76,     0,    41,    43,    76,     0,    42,
    43,    76,     0,    43,    43,    76,     0,    44,    43,    76,
     0,    21,     0,    45,    21,     0,    20,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   221,   222,   223,   224,   227,   233,   238,   244,   251,   256,
   263,   268,   269,   270,   271,   272,   273,   276,   277,   278,
   281,   284,   288,   323,   353,   362,   368,   369,   372,   375,
   381,   382,   390,   394,   401,   404,   407,   410,   413,   416,
   419,   422,   425,   428,   432,   435,   440,   443,   446,   449,
   452,   457,   460,   463,   468,   469,   473,   485,   491,   503,
   515,   518,   524,   529,   532,   537,   538,   542,   552,   562,
   572,   582,   592,   598,   603,   624,   625,   629,   632,   633,
   644,   654,   657,   658,   661,   662,   665,   668,   671,   679,
   689,   690,   693,   706,   710,   714,   718,   722,   726,   732,
   733,   737
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","CLASS",
"FROM","CONST","VOID","STRUCT","UNION","ENUM","THREEDOTS","SIGNED","UNSIGNED",
"LONG","SHORT","INT","FLOAT","DOUBLE","CHAR","ONERROR","TOKEN","NUMBER","TYPETOKEN",
"ARRAY_DIM","CCODE","HCODE","PUBLIC","PRIVATE","PROTECTED","ARGUMENT","VIRTUAL",
"SIGNAL","OVERRIDE","'{'","'}'","';'","'('","')'","'|'","'*'","','","'>'","'<'",
"'='","'!'","'-'","prog","ccodes","class","classdec","classcode","scope","variable",
"argument","argtype","argflags","flaglist","type","type1","type2","integer",
"tspecifier","stars","simplesigtype","fullsigtype","sigtype","tokenlist","codenocode",
"method","onerror","funcargs","arglist","arglist1","arg","checklist","check",
"numtok", NULL
};
#endif

static const short yyr1[] = {     0,
    46,    46,    46,    46,    47,    47,    47,    47,    48,    48,
    49,    50,    50,    50,    50,    50,    50,    51,    51,    51,
    52,    52,    53,    53,    54,    54,    55,    55,    56,    56,
    57,    57,    58,    58,    59,    59,    59,    59,    59,    59,
    59,    59,    59,    59,    59,    59,    60,    60,    60,    60,
    60,    61,    61,    61,    62,    62,    63,    63,    64,    64,
    64,    64,    65,    66,    66,    67,    67,    68,    68,    68,
    68,    68,    68,    68,    68,    69,    69,    69,    70,    70,
    70,    70,    71,    71,    72,    72,    73,    73,    73,    73,
    74,    74,    75,    75,    75,    75,    75,    75,    75,    76,
    76,    76
};

static const short yyr2[] = {     0,
     3,     2,     2,     1,     2,     2,     1,     1,     4,     3,
     4,     2,     2,     2,     1,     1,     1,     1,     1,     1,
     4,     5,    11,     8,     5,     1,     3,     0,     3,     1,
     1,     2,     1,     2,     2,     2,     1,     2,     2,     1,
     1,     1,     1,     2,     1,     1,     2,     1,     2,     1,
     1,     1,     1,     1,     2,     1,     2,     1,     3,     3,
     2,     1,     4,     3,     1,     2,     1,     9,    10,     9,
     9,     8,    11,     8,     5,     2,     3,     0,     1,     1,
     3,     1,     3,     1,     3,     1,     2,     3,     6,     7,
     2,     1,     1,     2,     2,     3,     3,     3,     3,     1,
     2,     1
};

static const short yydefact[] = {     0,
     0,     7,     8,     0,     4,     0,     0,     5,     6,     3,
     2,     0,     0,     1,     0,    18,    19,    20,    28,     0,
     0,     0,    10,     0,     0,    16,    17,    15,    11,     0,
     0,     0,     0,    46,    54,    53,    52,     0,     0,    48,
    50,    51,    42,    41,    40,    43,    45,     0,     0,    31,
    33,    37,     0,     0,     0,    62,     0,    58,     0,     9,
    13,    14,    12,     0,     0,     0,     0,    30,     0,    26,
     0,    32,    39,    36,    38,    35,    47,    49,     0,     0,
    56,    34,    44,     0,     0,     0,    57,     0,    61,     0,
     0,     0,     0,     0,     0,     0,     0,    27,     0,     0,
     0,     0,    55,    65,     0,    60,    59,     0,     0,     0,
     0,     0,    21,     0,     0,    67,    75,    29,     0,     0,
     0,    46,    43,     0,     0,    82,    84,    86,    63,     0,
     0,     0,     0,     0,    22,     0,    66,     0,     0,     0,
     0,    87,    78,     0,    64,     0,     0,     0,     0,    78,
    25,     0,    78,    81,    88,     0,     0,     0,    83,    85,
    78,     0,    78,     0,     0,     0,    24,     0,     0,     0,
   102,   100,     0,     0,    76,    72,     0,     0,     0,    78,
    74,     0,    70,     0,    93,     0,     0,     0,     0,     0,
    92,    77,   101,    68,    78,    71,     0,     0,     0,     0,
    94,     0,    95,     0,     0,    89,    91,     0,    69,    23,
    90,    96,    97,    98,    99,    73,     0,     0,     0
};

static const short yydefgoto[] = {   217,
     4,     5,     6,    24,    25,    26,    27,    71,    32,    69,
   124,    50,    51,    52,    53,    82,    56,    57,    58,   105,
   117,    28,   158,   125,   126,   127,   128,   190,   191,   175
};

static const short yypact[] = {    69,
   -13,-32768,-32768,    73,    89,   -19,    17,-32768,-32768,    89,
   125,   216,    11,   125,     6,-32768,-32768,-32768,    46,   115,
   120,    50,-32768,   229,    53,-32768,-32768,-32768,-32768,    68,
    76,    81,   206,-32768,-32768,-32768,-32768,   251,   257,    92,
   110,-32768,-32768,-32768,-32768,-32768,-32768,   171,   131,-32768,
   114,-32768,   135,   205,   152,-32768,   171,-32768,   159,-32768,
-32768,-32768,-32768,   171,   154,   170,   155,   161,   173,   172,
   196,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   207,   193,
   114,-32768,-32768,   194,   214,   215,-32768,   -10,-32768,   217,
   201,   219,   -10,   171,    56,   101,    76,-32768,   220,   231,
   218,   189,-32768,-32768,    -5,-32768,-32768,   226,   171,   232,
   233,   238,-32768,   189,   228,-32768,-32768,-32768,   171,   234,
   189,   237,    16,   256,   240,-32768,   239,-32768,-32768,   258,
   189,   260,   189,   245,-32768,   246,-32768,   247,   261,   249,
   171,    -7,   263,   153,-32768,   250,   252,   253,   189,   263,
-32768,    -8,   263,-32768,   255,   269,    10,   101,-32768,-32768,
   263,   189,   263,   259,   101,   262,-32768,   101,   272,     4,
-32768,-32768,   270,   276,-32768,-32768,   101,   264,   101,   263,
-32768,   274,-32768,     4,-32768,    57,    60,   265,   266,    67,
-32768,-32768,-32768,-32768,   263,-32768,   101,   267,    75,    18,
-32768,    18,-32768,    18,    18,-32768,-32768,   101,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   293,   299,-32768
};

static const short yypgoto[] = {-32768,
    80,   296,-32768,-32768,   -18,   279,   280,-32768,-32768,   208,
   -20,   273,-32768,   106,-32768,   230,   242,-32768,   -36,-32768,
  -157,   286,  -146,  -108,   174,-32768,   168,   129,   -84,   -48
};


#define	YYLAST		315


static const short yytable[] = {    49,
   176,    48,    55,   165,    66,   136,   168,   181,     7,    84,
   183,   166,   140,    12,   177,   155,   179,    87,    89,   194,
    13,   196,   146,   185,   148,    85,   167,    79,   156,   171,
   172,   129,    29,   197,   130,    86,    90,   171,   172,   209,
   164,    30,   173,    92,   186,   187,   188,   189,   208,   106,
   216,   107,   -80,   178,   174,   141,    87,    33,    34,    35,
    36,    37,   174,    38,    39,    40,    41,    42,    43,    44,
    45,     1,    46,   111,    47,     1,   171,   172,   112,   171,
   172,    31,    64,    65,    11,    59,   185,    67,   132,    14,
   113,   114,     2,     3,   185,    68,     8,     9,   138,   200,
    70,   174,   202,   206,   174,   207,    77,   186,   187,   188,
   189,   211,     2,     3,   207,   186,   187,   188,   189,    33,
    34,    35,    36,    37,    78,    38,    39,    40,    41,    42,
    43,    44,    45,   115,    46,   116,    47,   201,   203,    54,
    16,    17,    18,    74,    76,    16,    17,    18,     8,     9,
    80,   212,    81,   213,    83,   214,   215,    33,    34,    35,
    36,    37,   159,    38,    39,    40,    41,    42,    43,    44,
    45,    88,    46,    93,    47,    33,    34,    35,    36,    37,
    91,    38,    39,    40,    41,    42,    43,    44,    45,    95,
    46,    96,    47,    33,   122,    35,    36,    37,    97,    38,
    39,    40,    41,    42,    43,    44,    45,    99,   123,    98,
    47,    34,    35,    36,    37,   100,    38,    39,    40,    41,
    42,    43,    44,    45,    84,    46,   101,    47,   102,    85,
    16,    17,    18,   104,    84,    15,   108,   109,   110,   119,
    85,    16,    17,    18,    19,    20,    21,    22,    15,    23,
   120,   137,   134,   121,    16,    17,    18,    19,    20,    21,
    22,   131,    60,    40,    41,    42,   139,   133,    73,    40,
    41,    42,   135,   -79,    75,   142,   143,   145,   144,   147,
   149,   157,   150,   151,   152,   153,   161,   162,   170,   163,
   169,   184,   218,   192,   182,   180,   193,   198,   219,    10,
   195,   210,    61,    62,   118,    72,    94,   204,   205,    63,
   103,   160,   199,     0,   154
};

static const short yycheck[] = {    20,
   158,    20,    21,   150,    25,   114,   153,   165,    22,    20,
   168,    20,   121,    33,   161,    23,   163,    54,    55,   177,
     4,   179,   131,    20,   133,    36,    35,    48,    36,    20,
    21,    37,    22,   180,    40,    54,    57,    20,    21,   197,
   149,    36,    33,    64,    41,    42,    43,    44,   195,    86,
   208,    88,    37,   162,    45,    40,    93,     5,     6,     7,
     8,     9,    45,    11,    12,    13,    14,    15,    16,    17,
    18,     3,    20,    94,    22,     3,    20,    21,    23,    20,
    21,    36,    30,    31,     5,    36,    20,    20,   109,    10,
    35,    36,    24,    25,    20,    20,    24,    25,   119,    43,
    20,    45,    43,    37,    45,   190,    15,    41,    42,    43,
    44,    37,    24,    25,   199,    41,    42,    43,    44,     5,
     6,     7,     8,     9,    15,    11,    12,    13,    14,    15,
    16,    17,    18,    33,    20,    35,    22,   186,   187,    20,
    26,    27,    28,    38,    39,    26,    27,    28,    24,    25,
    20,   200,    39,   202,    20,   204,   205,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    20,    20,    20,    22,     5,     6,     7,     8,     9,
    22,    11,    12,    13,    14,    15,    16,    17,    18,    20,
    20,    37,    22,     5,     6,     7,     8,     9,    38,    11,
    12,    13,    14,    15,    16,    17,    18,    36,    20,    37,
    22,     6,     7,     8,     9,    20,    11,    12,    13,    14,
    15,    16,    17,    18,    20,    20,    20,    22,    36,    36,
    26,    27,    28,    20,    20,    20,    20,    37,    20,    20,
    36,    26,    27,    28,    29,    30,    31,    32,    20,    34,
    20,    24,    20,    36,    26,    27,    28,    29,    30,    31,
    32,    36,    34,    13,    14,    15,    33,    36,    18,    13,
    14,    15,    35,    37,    18,    20,    37,    20,    40,    20,
    36,    19,    37,    37,    24,    37,    37,    36,    20,    37,
    36,    20,     0,    24,    33,    37,    21,    24,     0,     4,
    37,    35,    24,    24,    97,    33,    65,    43,    43,    24,
    81,   144,   184,    -1,   141
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 221 "parse.y"
{ ; ;
    break;}
case 2:
#line 222 "parse.y"
{ ; ;
    break;}
case 3:
#line 223 "parse.y"
{ ; ;
    break;}
case 4:
#line 224 "parse.y"
{ ; ;
    break;}
case 5:
#line 227 "parse.y"
{
			Node *node = new_ccode(FALSE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 6:
#line 233 "parse.y"
{
			Node *node = new_ccode(TRUE,(yyvsp[0].cbuf)->str,ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 7:
#line 238 "parse.y"
{
			Node *node = new_ccode(FALSE,(yyvsp[0].cbuf)->str,
					       ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 8:
#line 244 "parse.y"
{
			Node *node = new_ccode(TRUE,(yyvsp[0].cbuf)->str,ccode_line);
			nodes = g_list_append(nodes,node);
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 9:
#line 251 "parse.y"
{
			((Class *)class)->nodes = class_nodes;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 10:
#line 256 "parse.y"
{
			((Class *)class)->nodes = NULL;
			class_nodes = NULL;
			nodes = g_list_append(nodes,class);
						;
    break;}
case 11:
#line 263 "parse.y"
{
			class = new_class(yyvsp[-2].id,yyvsp[0].id,NULL);
						;
    break;}
case 12:
#line 268 "parse.y"
{ ; ;
    break;}
case 13:
#line 269 "parse.y"
{ ; ;
    break;}
case 14:
#line 270 "parse.y"
{ ; ;
    break;}
case 15:
#line 271 "parse.y"
{ ; ;
    break;}
case 16:
#line 272 "parse.y"
{ ; ;
    break;}
case 17:
#line 273 "parse.y"
{ ; ;
    break;}
case 18:
#line 276 "parse.y"
{ the_scope = PUBLIC_SCOPE; ;
    break;}
case 19:
#line 277 "parse.y"
{ the_scope = PRIVATE_SCOPE; ;
    break;}
case 20:
#line 278 "parse.y"
{ the_scope = PROTECTED_SCOPE; ;
    break;}
case 21:
#line 281 "parse.y"
{
			push_variable(yyvsp[-1].id,the_scope,yyvsp[-3].line,NULL);
						;
    break;}
case 22:
#line 284 "parse.y"
{
			push_variable(yyvsp[-2].id,the_scope,yyvsp[-4].line,yyvsp[-1].id);
						;
    break;}
case 23:
#line 288 "parse.y"
{
			if(strcmp(yyvsp[-6].id,"get")==0 &&
			   strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-6].id,"set")==0 &&
				strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-8].id,type,yyvsp[-9].list,yyvsp[-7].id,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    (yyvsp[-4].cbuf)->str,yyvsp[-5].line,
						    yyvsp[-10].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				g_string_free(yyvsp[-4].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-8].id); g_free(yyvsp[-7].id);
				g_free(yyvsp[-6].id); g_free(yyvsp[-3].id);
				g_list_foreach(yyvsp[-9].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				g_string_free(yyvsp[-4].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 24:
#line 323 "parse.y"
{
			if(strcmp(yyvsp[-3].id,"get")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,type,yyvsp[-6].list,yyvsp[-4].id,
						    (yyvsp[-1].cbuf)->str,yyvsp[-2].line,
						    NULL,0, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else if(strcmp(yyvsp[-3].id,"set")==0) {
				Node *node;
				Type *type = pop_type();
				g_free(yyvsp[-3].id);
				node = new_argument(yyvsp[-5].id,type,yyvsp[-6].list,yyvsp[-4].id,
						    NULL,0,(yyvsp[-1].cbuf)->str,
						    yyvsp[-2].line, yyvsp[-7].line);
				g_string_free(yyvsp[-1].cbuf,FALSE);
				class_nodes = g_list_append(class_nodes,node);
			} else {
				g_free(yyvsp[-3].id); g_free(yyvsp[-5].id);
				g_free(yyvsp[-4].id);
				g_list_foreach(yyvsp[-6].list,(GFunc)g_free,NULL);
				g_string_free(yyvsp[-1].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 25:
#line 353 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"type")!=0) {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
			yyval.id = yyvsp[-4].id;
						;
    break;}
case 26:
#line 362 "parse.y"
{
			yyval.id = yyvsp[0].id;
			typestack = g_list_prepend(typestack,NULL);
						;
    break;}
case 27:
#line 368 "parse.y"
{ yyval.list = yyvsp[-1].list; ;
    break;}
case 28:
#line 369 "parse.y"
{ yyval.list = NULL; ;
    break;}
case 29:
#line 372 "parse.y"
{
			yyval.list = g_list_append(yyvsp[0].list,yyvsp[-2].id);
						;
    break;}
case 30:
#line 375 "parse.y"
{
			yyval.list = g_list_append(NULL,yyvsp[0].id);
						;
    break;}
case 31:
#line 381 "parse.y"
{ ; ;
    break;}
case 32:
#line 382 "parse.y"
{
			Type *type = typestack->data;
			char *oldname = type->name;
			type->name = g_strconcat("const ",oldname,NULL);
			g_free(oldname);
						;
    break;}
case 33:
#line 390 "parse.y"
{
			Node *node = new_type(0,yyvsp[0].id,NULL);
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 34:
#line 394 "parse.y"
{
			Node *node = new_type(stars,yyvsp[-1].id,NULL);
			stars = 0;
			typestack = g_list_prepend(typestack,node);
						;
    break;}
case 35:
#line 401 "parse.y"
{
			yyval.id = g_strconcat("unsigned ",yyvsp[0].id,NULL);
						;
    break;}
case 36:
#line 404 "parse.y"
{
			yyval.id = g_strconcat("signed ",yyvsp[0].id,NULL);
						;
    break;}
case 37:
#line 407 "parse.y"
{
			yyval.id = g_strdup(yyvsp[0].id);
						;
    break;}
case 38:
#line 410 "parse.y"
{
			yyval.id = g_strdup("unsigned char");
						;
    break;}
case 39:
#line 413 "parse.y"
{
			yyval.id = g_strdup("signed char");
						;
    break;}
case 40:
#line 416 "parse.y"
{
			yyval.id = g_strdup("char");
						;
    break;}
case 41:
#line 419 "parse.y"
{
			yyval.id = g_strdup("double");
						;
    break;}
case 42:
#line 422 "parse.y"
{
			yyval.id = g_strdup("float");
						;
    break;}
case 43:
#line 425 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 44:
#line 428 "parse.y"
{
			yyval.id = g_strconcat(yyvsp[-1].id,yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
						;
    break;}
case 45:
#line 432 "parse.y"
{
			yyval.id = yyvsp[0].id;
						;
    break;}
case 46:
#line 435 "parse.y"
{
			yyval.id = g_strdup("void");
						;
    break;}
case 47:
#line 440 "parse.y"
{
			yyval.id = "long int";
						;
    break;}
case 48:
#line 443 "parse.y"
{
			yyval.id = "long";
						;
    break;}
case 49:
#line 446 "parse.y"
{
			yyval.id = "short int";
						;
    break;}
case 50:
#line 449 "parse.y"
{
			yyval.id = "short";
						;
    break;}
case 51:
#line 452 "parse.y"
{
			yyval.id = "int";
						;
    break;}
case 52:
#line 457 "parse.y"
{
			yyval.id = "enum ";
						;
    break;}
case 53:
#line 460 "parse.y"
{
			yyval.id = "union ";
						;
    break;}
case 54:
#line 463 "parse.y"
{
			yyval.id = "struct ";
						;
    break;}
case 55:
#line 468 "parse.y"
{ stars++; ;
    break;}
case 56:
#line 469 "parse.y"
{ stars++; ;
    break;}
case 57:
#line 473 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 58:
#line 485 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 59:
#line 491 "parse.y"
{
			if(strcmp(yyvsp[-1].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-1].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-1].id);
				YYERROR;
			}
			g_free(yyvsp[-1].id);
					;
    break;}
case 60:
#line 503 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"first")==0)
				yyval.sigtype = SIGNAL_FIRST_METHOD;
			else if(strcmp(yyvsp[-2].id,"last")==0)
				yyval.sigtype = SIGNAL_LAST_METHOD;
			else {
				yyerror(_("signal must be 'first' or 'last'"));
				g_free(yyvsp[-2].id);
				YYERROR;
			}
			g_free(yyvsp[-2].id);
					;
    break;}
case 61:
#line 515 "parse.y"
{
			yyval.sigtype = SIGNAL_LAST_METHOD;
					;
    break;}
case 62:
#line 518 "parse.y"
{
			/* the_scope was default thus public */
			the_scope = PUBLIC_SCOPE;
					;
    break;}
case 63:
#line 524 "parse.y"
{
			gtktypes = g_list_prepend(gtktypes,yyvsp[-3].id);
						;
    break;}
case 64:
#line 529 "parse.y"
{
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
						;
    break;}
case 65:
#line 532 "parse.y"
{ 
			gtktypes = g_list_append(gtktypes,yyvsp[0].id);
       						;
    break;}
case 66:
#line 537 "parse.y"
{ yyval.cbuf = yyvsp[0].cbuf; ;
    break;}
case 67:
#line 538 "parse.y"
{ yyval.cbuf = NULL; ;
    break;}
case 68:
#line 542 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype,NULL,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-8].line,
				      ccode_line,vararg);
									;
    break;}
case 69:
#line 552 "parse.y"
{
			if(!has_self) {
				yyerror(_("signal without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(the_scope, yyvsp[-7].sigtype,NULL,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-8].line,
				      ccode_line,vararg);
									;
    break;}
case 70:
#line 562 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-8].line,
				      ccode_line,vararg);
									;
    break;}
case 71:
#line 572 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(the_scope, VIRTUAL_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-7].line,
				      ccode_line,vararg);
									;
    break;}
case 72:
#line 582 "parse.y"
{
			if(!has_self) {
				yyerror(_("virtual method without 'self' as "
					  "first parameter"));
				YYERROR;
			}
			push_function(PUBLIC_SCOPE, VIRTUAL_METHOD, NULL,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-7].line,
				      ccode_line,vararg);
									;
    break;}
case 73:
#line 592 "parse.y"
{
			push_function(NO_SCOPE, OVERRIDE_METHOD, yyvsp[-8].id,
				      yyvsp[-5].id, yyvsp[-1].id, yyvsp[0].cbuf,
				      yyvsp[-10].line,ccode_line,
				      vararg);
									;
    break;}
case 74:
#line 598 "parse.y"
{
			push_function(the_scope, REGULAR_METHOD, NULL, yyvsp[-5].id,
				      yyvsp[-1].id, yyvsp[0].cbuf,yyvsp[-7].line,ccode_line,
				      vararg);
								;
    break;}
case 75:
#line 603 "parse.y"
{
			if(strcmp(yyvsp[-4].id,"init")==0) {
				push_init_arg(yyvsp[-2].id,FALSE);
				push_function(NO_SCOPE, INIT_METHOD, NULL,
					      yyvsp[-4].id, NULL, yyvsp[0].cbuf,yyvsp[-3].line,
					      ccode_line,FALSE);
			} else if(strcmp(yyvsp[-4].id,"class_init")==0) {
				push_init_arg(yyvsp[-2].id,TRUE);
				push_function(NO_SCOPE, CLASS_INIT_METHOD, NULL,
					      yyvsp[-4].id, NULL, yyvsp[0].cbuf,yyvsp[-3].line,
					      ccode_line,FALSE);
			} else {
				g_free(yyvsp[-4].id);
				g_free(yyvsp[-2].id);
				g_string_free(yyvsp[-2].cbuf,TRUE);
				yyerror(_("parse error"));
				YYERROR;
			}
						;
    break;}
case 76:
#line 624 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 77:
#line 625 "parse.y"
{
			yyval.id = (yyvsp[0].cbuf)->str;
			g_string_free(yyvsp[0].cbuf,FALSE);
					;
    break;}
case 78:
#line 629 "parse.y"
{ yyval.id = NULL; ;
    break;}
case 79:
#line 632 "parse.y"
{ vararg = FALSE; has_self = FALSE; ;
    break;}
case 80:
#line 633 "parse.y"
{
			vararg = FALSE;
			has_self = TRUE;
			if(strcmp(yyvsp[0].id,"self")==0)
				push_self(yyvsp[0].id);
			else {
				g_free(yyvsp[0].id);
				yyerror(_("parse error"));
				YYERROR;
			}
       					;
    break;}
case 81:
#line 644 "parse.y"
{
			has_self = TRUE;
			if(strcmp(yyvsp[-2].id,"self")==0)
				push_self(yyvsp[-2].id);
			else {
				g_free(yyvsp[-2].id);
				yyerror(_("parse error"));
				YYERROR;
			}
					;
    break;}
case 82:
#line 654 "parse.y"
{ has_self = FALSE; ;
    break;}
case 83:
#line 657 "parse.y"
{ vararg = TRUE; ;
    break;}
case 84:
#line 658 "parse.y"
{ vararg = FALSE; ;
    break;}
case 85:
#line 661 "parse.y"
{ ; ;
    break;}
case 86:
#line 662 "parse.y"
{ ; ;
    break;}
case 87:
#line 665 "parse.y"
{
			push_funcarg(yyvsp[0].id,NULL);
								;
    break;}
case 88:
#line 668 "parse.y"
{
			push_funcarg(yyvsp[-1].id,yyvsp[0].id);
								;
    break;}
case 89:
#line 671 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-4].id,NULL);
								;
    break;}
case 90:
#line 679 "parse.y"
{
			if(strcmp(yyvsp[-2].id,"check")!=0) {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[-2].id);
			push_funcarg(yyvsp[-5].id,yyvsp[-4].id);
								;
    break;}
case 91:
#line 689 "parse.y"
{ ; ;
    break;}
case 92:
#line 690 "parse.y"
{ ; ;
    break;}
case 93:
#line 693 "parse.y"
{
			if(strcmp(yyvsp[0].id,"type")==0) {
				Node *node = new_check(TYPE_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else if(strcmp(yyvsp[0].id,"null")==0) {
				Node *node = new_check(NULL_CHECK,NULL);
				checks = g_list_append(checks,node);
			} else {
				yyerror(_("parse error"));
				YYERROR;
			}
			g_free(yyvsp[0].id);
					;
    break;}
case 94:
#line 706 "parse.y"
{
			Node *node = new_check(GT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 95:
#line 710 "parse.y"
{
			Node *node = new_check(LT_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 96:
#line 714 "parse.y"
{
			Node *node = new_check(GE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 97:
#line 718 "parse.y"
{
			Node *node = new_check(LE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 98:
#line 722 "parse.y"
{
			Node *node = new_check(EQ_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 99:
#line 726 "parse.y"
{
			Node *node = new_check(NE_CHECK,yyvsp[0].id);
			checks = g_list_append(checks,node);
					;
    break;}
case 100:
#line 732 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
case 101:
#line 733 "parse.y"
{
			yyval.id = g_strconcat("-",yyvsp[0].id,NULL);
			g_free(yyvsp[0].id);
					;
    break;}
case 102:
#line 737 "parse.y"
{ yyval.id = yyvsp[0].id; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 740 "parse.y"

